;;; -*- lisp -*- 
(in-package :cl-user)

(export 'HUNCHENTOOT::REQUEST-REALM 'HUNCHENTOOT)
(export 'HUNCHENTOOT::SESSION-REALM 'HUNCHENTOOT)

(defpackage :cl-webobjects
  (:nicknames :wo)
  (:use :cl :hunchentoot :alexandria :cl-ppcre)
  (:export :*html-4.01-strict*
	   :*html-4.01-transitional*
	   :*html-4.01-frameset*
	   :*xhtml-1.0-strict*
	   :*xhtml-1.0-transitional*
	   :*xhtml-1.0-frameset*
	   :*default-encoding*
	   :*rewind-parameter*	   
	   :*woserver-base-path*
					;:request-realm
	   :request-id-table-map
					;:dyna-id
	   :tag-empty-p
	   :tag-symbol-class
	   :strings-to-jsarray	  
	   :empty-string-p
	   :build-tagf
	   :parse-htcomponent-function
	   :page ;page classes hadle the whole rendering cycle
	   :page-writer
	   :page-can-print
	   :page-url
	   :page-lisplet
	   :page-current-form
	   :page-req-parameter
	   :page-json-id-list
	   :page-format
	   :page-format-raw
	   :page-script-files
	   :page-stylesheet-files
	   :page-class-initscripts
	   :page-instance-initscripts
	   :page-indent
	   :page-xmloutput
	   :page-doc-type
	   :htclass-body
	   :htcomponent	
	   :htcomponent-page
	   :htcomponent-body
;	   :setf-htcomponent-page
	   :htcomponent-attributes
	   :htcomponent-can-print
	   :htcomponent-empty
	   :htcomponent-client-id
	   :htcomponent-script-files
	   :htcomponent-stylesheet-files
	   :htcomponent-class-initscripts
	   :htcomponent-instance-initscript
	   :tag ;class for tags that accept body 
	   :tag-name
	   :tag-render-starttag
	   :tag-render-endtag
	   :htbody
	   :page-body-init-scripts
	   :htscript
	   :htlink
	   :hthead
	   :htstring	  
	   :$>
	   :$raw>
	   ;empty tags definition
	   :area>
	   :base>
	   :basefont>
	   :br>
	   :col>
	   :frame>
	   :hr>
	   :img>
	   :input>
	   :isindex>
	   :link>
	   :meta>
	   :param>
	   ;standard tags
	   :a>
	   :abbr>
	   :acronym>
	   :address>
	   :applet>
	   :b>
	   :bdo>
	   :big>
	   :blockquote>
	   :body>
	   :button>
	   :caption>
	   :center>
	   :cite>
	   :code>
	   :colgroup>
	   :dd>
	   :del>
	   :dfn>
	   :dir>
	   :div>
	   :dl>
	   :dt>
	   :em>
	   :fieldset>
	   :font>
	   :form>
	   :frameset>
	   :h1>
	   :h2>
	   :h3>
	   :h4>
	   :h5>
	   :h6>
	   :head>
	   :html>
	   :i>
	   :iframe>
	   :ins>
	   :kbd>
	   :label>
	   :legend>
	   :li>
	   :map>
	   :menu>
	   :noframes>
	   :noscript>
	   :object>
	   :ol>
	   :optgroup>
	   :option>
	   :p>
	   :pre>
	   :q>
	   :s>
	   :samp>
	   :script>
	   :select>
	   :small>
	   :span>
	   :strike>
	   :strong>
	   :style>
	   :sub>
	   :sup>
	   :table>
	   :tbody>
	   :td>
	   :textarea>
	   :tfoot>
	   :th>
	   :thead>
	   :title>
	   :tr>
	   :tt>
	   :u>
	   :ul>
	   :var>
	   ;; class modifiers	   	  
	   :page-content
	   :page-render
	   :generate-id
	   :wocomponent
	   :wocomponent-parameters
	   :wocomponent-informal-parameters
	   :wocomponent-allow-informal-parametersp
	   :wocomponent-template	   
	   :wocomponent-parameter-value
	   :wocomponent-before-rewind
	   :wocomponent-after-rewind
	   :wocomponent-before-prerender
	   :wocomponent-after-prerender
	   :wocomponent-before-render
	   :wocomponent-after-render
	   :make-component
	   :defcomponent
	   :cform
	   :cform>
	   :action-link
	   :action-link>
	   :cinput
	   :cinput>
	   :cselect
	   :cselect>
	   :csubmit
	   :csubmit>
	   :submit-link
	   :submit-link>
	   :lisplet
	   :lisplet-realm
	   :lisplet-pages
	   :lisplet-base-path
	   :lisplet-dispatch-method
	   :lisplet-register-page-location
	   :lisplet-register-resource-location
	   ;; woserver
	   :woserver	   
	   :woserver-register-lisplet
	   :woserver-unregister-lisplet
	   :woserver-start
	   :woserver-stop
	   :woserver-port
	   :woserver-sslport
	   :woserver-address
	   :woserver-name
	   :woserver-sslname
	   :woserver-mod-lisp-p
	   :woserver-use-apache-log-p
	   :woserver-input-chunking-p
	   :woserver-read-timeout
	   :woserver-write-timeout
	   #+(and :unix (not :win32)) :woserver-setuid
	   #+(and :unix (not :win32)) :woserver-setgid
	   #-:hunchentoot-no-ssl :woserver-ssl-certificate-file
	   #-:hunchentoot-no-ssl :woserver-ssl-privatekey-file
	   #-:hunchentoot-no-ssl :woserver-ssl-privatekey-password))
